---
title: AesGcmParams
slug: Web/API/AesGcmParams
tags:
  - API
  - AesGcmParams
  - Dictionary
  - Reference
  - Web Crypto API
---
<div>{{ APIRef("Web Crypto API") }}</div>

<p>The <strong><code>AesGcmParams</code></strong> dictionary of the <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API </a>represents the object that should be passed as the <code>algorithm</code> parameter into {{domxref("SubtleCrypto.encrypt()")}}, {{domxref("SubtleCrypto.decrypt()")}}, {{domxref("SubtleCrypto.wrapKey()")}}, or {{domxref("SubtleCrypto.unwrapKey()")}}, when using the <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#AES-GCM">AES-GCM</a> algorithm.</p>

<p>For details of how to supply appropriate values for this parameter, see the specification for AES-GCM: <a href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38d.pdf">NIST SP800-38D</a>, in particular section 5.2.1.1 on Input Data.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>name</code></dt>
 <dd>A {{domxref("DOMString")}}. This should be set to <code>AES-GCM</code>.</dd>
 <dt><code>iv</code></dt>
 <dd>A {{domxref("BufferSource")}} — the initialization vector. This must be unique for every encryption operation carried out with a given key. Put another way: never reuse an IV with the same key. The AES-GCM specification recommends that the IV should be 96 bits long, and typically contains bits from a random number generator. <a href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38d.pdf#%5B%7B%22num%22%3A65%2C%22gen%22%3A0%7D%2C%7B%22name%22%3A%22XYZ%22%7D%2C0%2C792%2Cnull%5D">Section 8.2 of the specification</a> outlines methods for constructing IVs. Note that the IV does not have to be secret, just unique: so it is OK, for example, to transmit it in the clear alongside the encrypted message.</dd>
 <dt><code>additionalData</code> {{optional_inline}}</dt>
 <dd>
 <p>A {{domxref("BufferSource")}}. This contains additional data that will not be encrypted but will be authenticated along with the encrypted data. If <code>additionalData</code> is given here then the same data must be given in the corresponding call to <code><a href="/en-US/docs/Web/API/SubtleCrypto/decrypt">decrypt()</a></code>:  if the data given to the <code>decrypt()</code> call does not match the original data, the decryption will throw an exception. This gives you a way to authenticate associated data without having to encrypt it.</p>

 <p>The bit length of <code>additionalData</code> must be <code>≤ 2<sup>64</sup>-1</code>.</p>

 <p>The <code>additionalData</code> property is optional and may be omitted without compromising the security of the encryption operation.</p>
 </dd>
 <dt><code>tagLength</code> {{optional_inline}}</dt>
 <dd>
 <p>A <code>Number</code>. This determines the size in bits of the authentication tag generated in the encryption operation and used for authentication in the corresponding decryption.</p>

 <p>According to the <a href="https://www.w3.org/TR/WebCryptoAPI/#dfn-AesGcmParams">Web Crypto specification</a> this must have one of the following values: 32, 64, 96, 104, 112, 120, or 128. The AES-GCM specification recommends that it should be 96, 104, 112, 120 or 128, although 32 or 64 bits may be acceptable in some applications: <a href="https://nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38d.pdf#%5B%7B%22num%22%3A92%2C%22gen%22%3A0%7D%2C%7B%22name%22%3A%22XYZ%22%7D%2C0%2C792%2Cnull%5D">Appendix C of the specification</a> provides additional guidance here.</p>

 <p><code>tagLength</code> is optional and defaults to 128 if it is not specified.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>See the examples for {{domxref("SubtleCrypto.encrypt()")}} and {{domxref("SubtleCrypto.decrypt()")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Web Crypto API', '#dfn-AesGcmParams', 'SubtleCrypto.AesGcmParams') }}</td>
   <td>{{ Spec2('Web Crypto API') }}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>Browsers that support the "AES-GCM" algorithm for the {{domxref("SubtleCrypto.encrypt()")}}, {{domxref("SubtleCrypto.decrypt()")}}, {{domxref("SubtleCrypto.wrapKey()")}}, or {{domxref("SubtleCrypto.unwrapKey()")}} methods will support this type.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("SubtleCrypto.encrypt()")}}.</li>
 <li>{{domxref("SubtleCrypto.decrypt()")}}.</li>
 <li>{{domxref("SubtleCrypto.wrapKey()")}}.</li>
 <li>{{domxref("SubtleCrypto.unwrapKey()")}}.</li>
</ul>
